#include "testlib.h"
#include <vector>
using namespace std;

int main(int argc, char** argv) {
    registerTestlibCmd(argc, argv);

    int ja = ans.readInt();
    int pa = ouf.readInt();
    if (ja < pa) {
        quitf(_wa, "expected: %d, found: %d", ja, pa);
    }

    int k = inf.readInt();
    int m = inf.readInt();
    vector<int> a;
    for (int i = 0; i < m; i++) {
        a.push_back(inf.readInt());
    }
    int n = inf.readInt();
    vector<int> b;
    for (int i = 0; i < n; i++) {
        b.push_back(inf.readInt());
    }

    vector<int> c;
    for (int i = 0; i < pa; i++) {
        c.push_back(ouf.readInt());
        if (c[i] < 1 || c[i] > k) {
            quitf(_wa, "invalid subsequence element %d", c[i]);
        }
    }

    int j = -1;
    int i = 0;
    while (i < pa && j < m) {
        j++;
        while (j < m && a[j] != c[i]) {
            j++;
        }
        i++;
    }
    if (j < m) {
        quitf(_wa, "subsequence of a");
    }
    j = -1;
    i = 0;
    while (i < pa && j < n) {
        j++;
        while (j < n && b[j] != c[i]) {
            j++;
        }
        i++;
    }
    if (j < n) {
        quitf(_wa, "subsequence of b");
    }

    if (ja > pa) {
        quitf(_fail, "expected: %d, found: %d", ja, pa);
    }

    quitf(_ok, "k = %d, n = %d, m = %d, ans = %d", k, n, m, ja);
}