import java.io.*;
import java.util.*;

public class f_as implements Runnable {
    BufferedReader in;
    StringTokenizer st;

    int nextInt() {
        while (st == null || !st.hasMoreTokens()) {
            try {
                st = new StringTokenizer(in.readLine());
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        return Integer.parseInt(st.nextToken());
    }

    public void solve() throws IOException {
        in = new BufferedReader(new InputStreamReader(System.in));
        PrintWriter out = new PrintWriter(System.out);

        int cn = nextInt();
        assert 1 <= cn && cn <= 5000;
        int m = nextInt();
        assert 1 <= m && m <= 5000;
        int[] a = new int[m];
        for (int i = 0; i < m; i++) {
            a[i] = nextInt() - 1;
            assert 0 <= a[i] && a[i] <= cn - 1;
        }
        int n = nextInt();
        assert 1 <= n && n <= 5000;
        int[] b = new int[n];
        for (int i = 0; i < n; i++) {
            b[i] = nextInt() - 1;
            assert 0 <= b[i] && b[i] <= cn - 1;
        }

        if (cn == 1) {
            out.println(Math.max(n, m) + 1);
            for (int i = 0; i < Math.max(n, m) + 1; i++) {
                out.print("1 ");
            }
            out.close();
            return;
        }

        int[][] nexta = new int[m + 2][cn];
        Arrays.fill(nexta[m + 1], m + 1);
        int[] firsta = new int[cn];
        Arrays.fill(firsta, m + 1);
        for (int i = m; i >= 0; i--) {
            if (i < m) {
                firsta[a[i]] = i + 1;
            }
            for (int j = 0; j < cn; j++) {
                nexta[i][j] = firsta[j];
            }
        }

        int[][] nextb = new int[n + 2][cn];
        Arrays.fill(nextb[n + 1], n + 1);
        int[] firstb = new int[cn];
        Arrays.fill(firstb, n + 1);
        for (int i = n; i >= 0; i--) {
            if (i < n) {
                firstb[b[i]] = i + 1;
            }
            for (int j = 0; j < cn; j++) {
                nextb[i][j] = firstb[j];
            }
        }

        int[] bestbo = new int[m + 2];
        int[] bestb = new int[m + 2];
        Arrays.fill(bestb, -1);
        bestb[0] = 0;

        int[][] lastc = new int[m / cn + 1 + n / cn + 1][m + 2];
        int[][] from = new int[m / cn + 1 + n / cn + 1][m + 2];
        int curl = 0;

        while (bestb[m + 1] <= n) {
//            System.out.println(curl + " " + Arrays.toString(bestb));
            int[] tmp = bestbo;
            bestbo = bestb;
            bestb = tmp;

            Arrays.fill(bestb, -1);

            for (int i = 0; i <= m + 1; i++) {
                if (bestbo[i] != -1) {
                    for (int j = 0; j < cn; j++) {
                        int ga = nexta[i][j];
                        int gb = nextb[bestbo[i]][j];
                        if (bestb[ga] < gb) {
                            bestb[ga] = gb;
                            lastc[curl][ga] = j;
                            from[curl][ga] = i;
                        }
                    }
                }
            }
            curl++;
        }

        out.println(curl);
        ArrayList<Integer> ans = new ArrayList<Integer>();
        int curp = m + 1;
        while (curl > 0) {
            ans.add(lastc[curl - 1][curp]);
            curp = from[curl - 1][curp];
            curl--;
        }

        for (int i = ans.size() - 1; i >= 0; i--) {
            out.print((ans.get(i) + 1) + " ");
        }

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
            System.exit(1);
        }
    }

    public static void main(String[] s) {
        new Thread(new f_as()).start();
    }
}